﻿function KOTable() {
	var self = this;
	this.method = "GET";
	this.loadGrid = ko.observable(false);
	this.total = ko.observable(0);
	this.pageindex = ko.observable(1);
	this.pagesize = ko.observable(10);
	this.startButton = ko.observable(0);
	this.endButtton = ko.observable(0);
	this.totalpages = ko.observable(0);
	this.sortname = ko.observable("");
	this.sortorder = ko.observable("asc");
	this.url = ko.observable("");
	this.viewModel = ko.observable();
	this.rows = ko.observableArray(new Array());
	this.pagesizes = [10, 15, 25, 50];
	this.params = new Array();
	this.columns = new Array();
	this.container = null;
	this.gridbox = null;
	this.tableHeaderTemplateID = "";
	this.tableBodyTemplateID = "";
	this.gridHeaderTemplateID = "";
	this.gridModeTemplateID = "";
	this.paging = true;
	this.displayMode = ko.observable("Table");
	this.displayModes = ['Table', 'Grid'];
	this.onInitGrid = null;
	this.onUpdateRows = null;
	this.onAddRow = null;
	this.getGridHeader = function () {
		return $(".grid-header", this.container);
	};
	this.getGridContent = function () {
		return $(".grid-content", this.container);
	};
	this.getGridFooter = function () {
		return $(".grid-footer", this.container);
	};
	this.render = function () {
		var html = "<div class='grid-box'>";
		if (this.gridHeaderTemplateID != "") {
			html += "<div class=\"grid-header\" data-bind=\"template: { name: '" + this.gridHeaderTemplateID + "'}\"></div>";
		}
		html += "<!-- ko if: displayMode() == 'Table' -->";
		html += "<div class='grid-content'>";
		html += "<table cellpadding=0 cellspacing=0 border=0 class='table table-hover'>";
		html += "<thead>";
		$.each(this.columns, function (i, column) {
			if (!column.sortname) {
				column.sortname = "";
			}
			if (!column.width) {
				column.width = "";
			}
			if (!column.align) {
				column.align = "left";
			}
			if (!column.sortorder) {
				column.sortorder = "asc";
			}
		});
		if (this.tableHeaderTemplateID != "") {
			html += "<tr data-bind='template: { name: '" + this.tableHeaderTemplateID + "', foreach: columns, as: 'column' }'>";
			html += "</tr>";
		} else {
			html += "<tr data-bind='foreach: columns'>";
			html += "<th data-bind=\"style: { width: width, textAlign: align }, click: $root.changeSort, css: { sortcol: (sortname != ''),  sorting_asc: ($root.sortname()==sortname && $root.sortorder()=='asc'),  sorting_desc: ($root.sortname()==sortname && $root.sortorder()=='desc') }\">";
			html += "<!-- ko if: sortname != '' -->";
			html += "<span class=\"column-sort\">"
			html += "<a class='sort-up' title='Sort up'  href='javascript:void(0)'></a>";
			html += "<a class='sort-down' title='Sort down' href='javascript:void(0)'></a>";
			html += "</span>";
			html += "<!-- /ko -->";
			html += "<span data-bind='html: display'></span>";
			html += "</th>";
			html += "</tr>";
		}
		html += "</thead>";
		if (this.tableBodyTemplateID != "") {
			html += "<tbody data-bind=\"template: { name: '" + this.tableBodyTemplateID + "', foreach: rows, as: 'row' }\">";
			html += "</tbody>";
		} else {
			html += "<tbody data-bind='foreach: rows'>";
			html += "<tr data-bind=\"css: { odd: ($index() % 2 == 1), even: ($index() % 2 == 0) }\">";
			$.each(this.columns, function (i, column) {
				if (column.template) {
					html += "<td data-bind='with:$data, style: { textAlign: \"" + column.align + "\" }'>";
					html += column.template();
				} else {
					html += "<td data-bind=\"html: " + column.dataName + ", style: { textAlign: '" + column.align + "' }\">";
				}
				html += "</td>";
			});
			html += "</tr>";
			html += "</tbody>";
		}
		html += "</table>";
		html += "</div>";
		html += "<!-- /ko -->";
		if (this.gridModeTemplateID != "") {
			html += "<!-- ko if: displayMode() == 'Grid' -->";
			html += "<div class=\"grid-content grid-mode\" data-bind=\"template: { name: '" + this.gridModeTemplateID + "' }\">";
			html += "</div>";
			html += "<!-- /ko -->";
		}
		html += "<div class='grid-footer'>";
		html += "<div class=\"record-status\">";
		html += "<span data-bind=\"text:recordStatus\"></span>";
		html += "</div>";
		html += "<div class=\"grid-footer-paging\">";
		html += "<div class=\"pull-left\">";
		html += "<div class=\"pull-left lbl-show\">Show</div>";
		html += "<div class=\"pull-left\">";
		html += "<select name=\"rows\" style=\"width:60px;\" disable_search=\"true\" data-bind=\"options:pagesizes,  value: pagesize\">";
		html += "</select>";
		html += "</div>";
		html += "<div class=\"clear\">&nbsp;</div>";
		html += "</div>";
		if (this.gridModeTemplateID != "") {
			html += "<div class=\"pull-right\">";
			html += "<div class=\"pull-left lbl-show\">Display Mode</div>";
			html += "<div class=\"pull-left\">";
			html += "<select name=\"rows\" style=\"width:100px;\" disable_search=\"true\" data-bind=\"options:displayModes,  value: displayMode\">";
			html += "</select>";
			html += "</div>";
			html += "<div class=\"clear\">&nbsp;</div>";
			html += "</div>";
		}
		html += "<div class=\"pull-right paging\">";
		html += "<ul>";
		html += "<li><a class=\"btn\" href=\"javascript:;\" data-bind=\"click: function() { if($root.pageindex()==1){return;} $root.firstPage(); }\">First</a></li>";
		html += "<li><a class=\"btn\" href=\"javascript:;\" data-bind=\"click: function() { if($root.pageindex()==1){return;} $root.prevPage(); }\">Prev</a></li>";
		html += "<!-- ko foreach: ko.utils.range($root.startButton(), $root.endButtton()) -->";
		html += "<li><a class=\"btn\" href=\"javascript:;\" data-bind=\"css: { current: $root.pageindex() == $data }, text:$data, click: function() { if($root.pageindex()==$data){return;} $root.changePage($data); }\"></a></li>";
		html += "<!-- /ko -->";
		html += "<li><a class=\"btn\" href=\"javascript:;\" data-bind=\"click: function() { if($root.pageindex()==$root.totalpages()){return;} $root.nextPage(1); }\">Next</a></li>";
		html += "<li><a class=\"btn\" href=\"javascript:;\" data-bind=\"click: function() { if($root.pageindex()==$root.totalpages()){return;} $root.lastPage(1); }\">Last</a></li>";
		html += "<li class=\"sep\"><a href=\"javascript:;\">&nbsp;</a></li>";
		html += "<li><a class=\"btn\" href=\"javascript:;\" data-bind=\"click: function() { $root.reload(); }\"><span class=\"reload-grid\"></span></a></li>";
		html += "</ul>";
		html += "</div>";
		html += "<div class=\"clear\">&nbsp;</div>";
		html += "</div>";
		html += "</div>";
		html += "</div>";
		this.gridbox = $(html);
		this.container.append(this.gridbox);
		ko.applyBindings(self, $(self.container).get(0));
		jhelper.initChosen($(self.container));
		if (self.onInitGrid) {
			self.onInitGrid();
		}
		self.loadGrid(true);
	};
	this.recordStatus = ko.computed(function () {
		var from = ((self.pageindex() - 1) * self.pagesize()) + 1;
		var to = (self.pageindex() * self.pagesize());
		if (to >= self.total()) {
			to = self.total();
		}
		return "Showing " + from + " to " + to + " of " + self.total();
	});
	this.renderPages = ko.computed(function () {
		var iPageCount = 5;
		var iPageCountHalf = Math.floor(iPageCount / 2);
		var iPages = Math.ceil(self.total() / self.pagesize());
		var iCurrentPage = self.pageindex();
		var iStartButton, iEndButton, i, iLen;
		/* Pages calculation */
		if (iPages < iPageCount) {
			iStartButton = 1;
			iEndButton = iPages;
		}
		else if (iCurrentPage <= iPageCountHalf) {
			iStartButton = 1;
			iEndButton = iPageCount;
		}
		else if (iCurrentPage >= (iPages - iPageCountHalf)) {
			iStartButton = iPages - iPageCount + 1;
			iEndButton = iPages;
		}
		else {
			iStartButton = iCurrentPage - Math.ceil(iPageCount / 2) + 1;
			iEndButton = iStartButton + iPageCount - 1;
		}
		self.totalpages(iPages);
		self.startButton(iStartButton);
		self.endButtton(iEndButton);
	});
	this.changePageSize = function (that) {
		self.pagesize(that.value);
	};
	this.changeSort = function (that) {
		if (that.sortname == "") { return; }
		self.loadGrid(false);
		if (self.sortorder() == "asc") { self.sortorder("desc"); } else { self.sortorder("asc"); }
		if (self.sortname() != that.sortname) {
			self.sortorder("asc");
		}
		self.sortname(that.sortname);
		self.loadGrid(true);
	};
	this.changePage = function (pageindex) {
		self.pageindex(pageindex);
	};
	this.firstPage = function () {
		self.pageindex(1);
	};
	this.nextPage = function () {
		self.pageindex(self.pageindex() + 1);
	};
	this.lastPage = function () {
		self.pageindex(self.totalpages());
	};
	this.prevPage = function () {
		self.pageindex(self.pageindex() - 1);
	};
	this.reload = function () {
		var url = self.url();
		if (self.loadGrid() == false) { return; }
		var params = new Array();
		$.each(self.params, function (i, para) {
			params[params.length] = { "name": para.name, "value": para.value }
		});
		params[params.length] = { "name": "pageindex", "value": self.pageindex() }
		params[params.length] = { "name": "pagesize", "value": self.pagesize() }
		params[params.length] = { "name": "sortname", "value": self.sortname() }
		params[params.length] = { "name": "sortorder", "value": self.sortorder() }
		$.ajax({
			type: self.method,
			url: url,
			data: params,
			dataType: "json",
			cache: false,
			success: function (data) {
				self.total(data.total);
				self.rows.removeAll();
				$.each(data.rows, function (i, row) {
					if (self.onAddRow) {
						self.onAddRow(row);
					} else {
						self.rows.push(row);
					}
				});
				if (self.onUpdateRows) {
					self.onUpdateRows();
				}
			},
			error: function (data) { try { if (p.onError) { p.onError(data); } } catch (e) { } }
		});
	};
	this.reloadGrid = ko.computed(function () {
		self.reload();
	});
}