// Numeric only control handler
(function($) {
	var methods = {
		init: function(options){
			return this.each(function(){
				$(this).attr("is-num-only", true);

				$(this).on("keydown", function(e){
					var key = e.charCode || e.keyCode || 0;
					// allow Backspace, Tab, Delete, Home, End, Arrows, Numbers and Keypad numbers ONLY
					return (
						key == 8 || key == 9 || key == 36 || key == 35 || key == 46 ||
						(key >= 37 && key <= 40) ||
						(key >= 48 && key <= 57) ||
						(key >= 96 && key <= 105)
					);
				});
			});
		},
		update : function(content) {
			return this.each(function(){
				if (!$(this).attr("is-num-only"))
				{
					$(this).NumberOnly();
				}
			});
		},
	};
	jQuery.fn.NumberOnly = function(options)
	{
		var settings = $.extend( {
		      'min' : 0,
		      'max' : 0,
	    }, options);

		if ( methods[options] )
		{
			return methods[options].apply( this, Array.prototype.slice.call( arguments, 1 ));
		}
		else if ( typeof options === 'object' || ! options )
		{
			return methods.init.apply( this, arguments );
		}
		else
		{
			$.error( 'Method ' +  options + ' does not exist on jQuery.NumberOnly' );
		}
	};
})(jQuery);
