<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
	
?>
<div class="row nm">
	<h3><?php echo lang('FINALISING_INSTALLATION'); ?></h3>
	<div class="col-md-6">
		<table class="table table-hover" data-bind="with:dbConfig">
			<colgroup>
				<col width="35%">
				<col>
			</colgroup>
			<thead>
				<th colspan="2"><?php echo lang('DATABASE_SETTINGS'); ?></th>
			</thead>
			<tbody>
				<tr>
					<td><?php echo lang('DATABASE_DRIVER'); ?></td>
					<td data-bind="text:dbdriver"></td>
				</tr>
				<tr>
					<td><?php echo lang('HOST_NAME'); ?></td>
					<td data-bind="text:hostname"></td>
				</tr>
				<tr>
					<td><?php echo lang('USER_NAME'); ?></td>
					<td data-bind="text:username"></td>
				</tr>
				<tr>
					<td><?php echo lang('PASSWORD'); ?></td>
					<td data-bind="if:password">*****</td>
				</tr>
				<tr>
					<td><?php echo lang('DATABASE_NAME'); ?></td>
					<td data-bind="text:database"></td>
				</tr>
			</tbody>
		</table>
		<table class="table table-hover" data-bind="with:smtpConfig">
			<colgroup>
				<col width="35%">
				<col>
			</colgroup>
			<thead>
				<th colspan="2"><?php echo lang('SMTP_SETTINGS'); ?></th>
			</thead>
			<tbody>
				<tr>
					<td><?php echo lang('SMTP_HOST_NAME'); ?></td>
					<td data-bind="text:smtp_host"></td>
				</tr>
				<tr>
					<td><?php echo lang('SMTP_PORT'); ?></td>
					<td data-bind="text:smtp_port"></td>
				</tr>
				<tr>
					<td><?php echo lang('SMTP_USER_NAME'); ?></td>
					<td data-bind="text:smtp_user"></td>
				</tr>
				<tr>
					<td><?php echo lang('SMTP_PASSWORD'); ?></td>
					<td data-bind="if:smtp_pass">*****</td>
				</tr>
			</tbody>
		</table>
	</div>
	<div class="col-md-6">
		<table class="table table-hover" data-bind="with:otherDetails">
			<colgroup>
				<col width="35%">
				<col>
			</colgroup>
			<thead>
				<th colspan="2"><?php echo lang('USER_DETAILS'); ?></th>
			</thead>
			<tbody>
				<tr>
					<td><?php echo lang('STEP4_EMAIL'); ?></td>
					<td data-bind="text:email"></td>
				</tr>
				<tr>
					<td><?php echo lang('STEP4_PASSWORD'); ?></td>
					<td data-bind="if:password">*****</td>
				</tr>
				<tr>
					<td><?php echo lang('STEP4_FIRST_NAME'); ?></td>
					<td data-bind="text:first_name"></td>
				</tr>
				<tr>
					<td><?php echo lang('STEP4_LAST_NAME'); ?></td>
					<td data-bind="text:last_name"></td>
				</tr>
			</tbody>
		</table>
		<table class="table table-hover" data-bind="with:licenseDetails">
			<colgroup>
				<col width="35%">
				<col>
			</colgroup>
			<thead>
				<th colspan="2"><?php echo lang('LICENSE_DETAILS'); ?></th>
			</thead>
			<tbody>
				<tr>
					<td><?php echo lang('STEP4_LICENSE_KEY'); ?></td>
					<td><pre style="white-space:normal;" data-bind="text:license_key"></pre></td>
				</tr>
				<tr>
					<td><?php echo lang('COMPANY_NAME'); ?></td>
					<td data-bind="text:company_name"></td>
				</tr>
				<tr>
					<td><?php echo lang('EXPIRY_DATE'); ?></td>
					<td data-bind="text:expiry_date"></td>
				</tr>
				<tr>
					<td><?php echo lang('MAX_USERS'); ?></td>
					<td data-bind="text:max_users"></td>
				</tr>
			</tbody>
		</table>
	</div>
	<div class="form-horizontal">
		<div class="form-group">
			<div class="col-sm-12">
				<input type="button" data-bind="click:prev, disable:show_loading" class="btn btn-success btn-big" value="Previous" />
				<input type="button" id="finish" data-bind="click:next, disable:show_loading" class="btn btn-success btn-big pull-right" value="Install" />
			</div>
		</div>
	</div>
</div>
